"use strict";

// script modified by Marc Geldon (https://www.proitsystems.de)
// original script by Arash Ramin (https://www.digitalroom.net)
    function _setCurrentDate() {
      // changes the date selector menus to the current date
      var currentDate = new Date();
      document.modify.year.selectedIndex = 0;
      document.modify.month.selectedIndex = currentDate.getMonth();
      setDays();
      document.modify.day.selectedIndex = currentDate.getDate() - 1;
    }

    function _setDays() {
      var y = document.modify.year.options[document.modify.year.selectedIndex].value;
      var m = document.modify.month.selectedIndex;
      var d;
      // find number of days in current month
      if ( (m == 3) || (m == 5) || (m == 8) || (m == 10) ) {
        days = 30;
      } else if (m == 1) {
        // check for leapyear - Any year divisible by 4, except those divisible by 100 (but NOT 400)
        if ( (Math.floor(y/4) == (y/4)) && ((Math.floor(y/100) != (y/100)) || (Math.floor(y/400) == (y/400))) ) {
          days = 29;
        } else {
          days = 28;
        }
      } else {
        days = 31;
      }
      // if (days in new month > current days) then we must add the extra days
      if (days > document.modify.day.length) {
        for (i = document.modify.day.length; i < days; i++) {
          document.modify.day.length = days;
          document.modify.day.options[i].text = i + 1;
          document.modify.day.options[i].value = i + 1;
        }
      }
  // if (days in new month < current days) then we must delete the extra days
      if (days < document.modify.day.length) {
        document.modify.day.length = days;
        if (document.modify.day.selectedIndex == -1) {
          document.modify.day.selectedIndex = days - 1;
        }
      }
    }

/* ------------------------------------------------------------------------ */

    function zeroFill(number, width) {
        width -= (number.toString().length - /\./.test(number));
        if (width > 0) {
            return new Array(width + 1).join('0') + number;
        }
        return number + ""; // always return a string
    }

// create a new option
    function createNewsList(selectBox,len,select) {
        for (let i=0; i<(len); i++){
            let val = zeroFill(i+1,2);
            let option = new Option(val, val,false,select[i+1]);
        // add it to the list
            selectBox.add(option, undefined);
        }
    }

    function removeAll(selectBox) {
        let index = selectBox.options.length;
        while (index--) {
                selectBox.remove(index);
        }
    }

    function setSelect(elm, len){
        let opt = elm.length,
        d = parseInt(elm.value),
        select = [];
//console.log(d);
// save the selected option
        select[d] = true;
        if (opt !== len){
            removeAll(elm);
            createNewsList(elm,len,select);
        }
    }

    function getDays() {
      let mod = document.querySelector(".modify-concert");
      if (mod){
          let days = null,
          extra = '';
          const day = document.getElementById('day-view'),
          d = parseInt(day.value),
          month = document.getElementById('month-view'),
          m = parseInt(month.value),
          name = month.options[month.selectedIndex].text,
          year = document.getElementById('year-view').value,
          out = document.querySelector("#concert_day-view"),
          output = document.getElementById('output'),
          array31 = [1, 3, 5, 7, 8, 10, 12],
          array30 = [4, 6, 9, 11];

          if (array31.includes(m)) {
              days = 31;
          }
          else if (array30.includes(m)) {
              days = 30;
          }
          else {
            const date29_2 = new Date(year,1,29);
            if (date29_2.getMonth() == 1) {
              days = 29;
              extra = 'und ist ein Schaltjahr';
            }
            else {
              days = 28;
              extra = ' und ist ein Gemeinjahr';
            }
          }
          output.innerHTML = 'Der ' + name + ' '+year+' hat insgesamt '+days+' Tage'+extra+".";
          out.innerHTML =""+year+"-"+zeroFill(m,2)+"-"+zeroFill(d,2);
          setSelect(day, days) ;
      }
    }

/* ------------------------------ search in table with fix header and scrollbar ------------------------------------- */
        function concertSelect() {
            var input,filter,sec_id,select,tr,txt,i,txtValue;
            input = document.querySelector("#concertInput");
//console.log(event.target.value);
            if (input){
                filter = input.value.toUpperCase();
                sec_id = input.dataset.sec;
//console.log(filter);
                select = document.querySelector("#concertResult_"+sec_id);
                if (select){
                    tr = select.getElementsByTagName("tr");
                    for (i = 0; i < tr.length; i++) {
                        txtValue = tr[i].textContent || tr[i].innerText;
//console.log(tr[i]);
                        if (txtValue.toUpperCase().indexOf(filter) > -1) {
                            tr[i].style.display = "";
                        } else {
                            tr[i].style.display = "none";
                        }
                    }
                }
            }
        }

domReady(function() {


// search routines
    let posts = document.querySelector("input#concertInput");
    if (posts){
//console.log(posts);
        posts.onkeyup = (function() {concertSelect()});
    }

//    document.addEventListener('change',setDays);
    document.addEventListener('change',getDays);

});
    document.addEventListener('DOMContentLoaded',getDays);
//    document.addEventListener('DOMContentLoaded',setCurrentDate);
