<?php
/*

 Website Baker Project <http://www.websitebaker.org/>
 Copyright (C) 2004-2008, Ryan Djurovich

 Website Baker is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Website Baker is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

use bin\{WbAdaptor,SecureTokens};
use bin\helpers\{PreCheck};


    $sAddonPath   = str_replace('\\','/',__DIR__).'/';
    $sModulesPath = \dirname($sAddonPath).'/';
    $sAddonName   = basename($sAddonPath);
    $sPattern = "/^(.*?\/)modules\/.*$/";
    $sAppPath = preg_replace ($sPattern, "$1", $sAddonPath, 1 );
    if (!defined('SYSTEM_RUN')) {require($sAppPath.'/config.php');}

    $sAddonName = \basename(__DIR__);
    $sAddonRel  = '/modules/'.$sAddonName;
    $sAddonUrl  = WB_URL.$sAddonRel;
    $sDumpPathname = \basename(__DIR__).'/'.\basename(__FILE__);
    $sChecked     = ' checked="checked"';
    $sSelected    = ' selected="selected"';

//  Only for Development as pretty mysql dump
    $sLocalDebug  =  is_readable($sAddonPath.'/.setDebug');
    $sSecureToken = !is_readable($sAddonPath.'/.setToken');
    $sPHP_EOL     = ($sLocalDebug ? "\n" : '');

try {

    // to print with or without header, default is with header
    $admin_header=false;
    // Workout if the developer wants to show the info banner
    $print_info_banner = false; // true/false
    // Tells script to update when this page was last updated
    $update_when_modified = false;
    // Include WB admin wrapper script to sanitize page_id and section_id, print SectionInfoLine
    require(WB_PATH.'/modules/admin.php');
// Get id
    $concert_id = ($admin->getIdFromRequest('concert_id') ?? false);
    $admin->print_header();

    $sec_anchor = '#'.(\defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' ).(int)$section_id;
    $sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;
// Delete post
//    $concert_id = 999;
    if ($concert_id) {
        if ($database->get_one('SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_concert_dates` WHERE `concert_id`='.(int)$concert_id))
        {
            $sSql = 'DELETE FROM `'.TABLE_PREFIX.'mod_concert_dates` '
                  . 'WHERE `concert_id` = '.(int)$concert_id.' ';
            if ($oDeleted = $database->query($sSql)){
                $sErrorMessage = \sprintf("concert_id (%d) %s\n",($concert_id ?? 0),$TEXT['DELETED']);
                $admin->print_success($sErrorMessage, $sAddonBackUrl);
            }
// Check if there is a db error, otherwise say successful
            if($database->is_error()) {
                $sErrorMessage = \sprintf($database->get_error());
                throw new \Exception ($sErrorMessage);
            }
        } else {
          $sErrorMessage = \sprintf("concert_id (%d) %s\n",($concert_id ?? 0),$TEXT['NOT_FOUND']);
          throw new \Exception ($sErrorMessage);
        }
    } else {
       $sErrorMessage = \sprintf("concert_id (%d) %s\n",($concert_id ?? 0),$TEXT['NOT_FOUND']);
       throw new \Exception ($sErrorMessage);
    }

}catch (\Exception $ex) {
    $sErrMsg = PreCheck::xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}


// Print admin footer
$admin->print_footer();
