<?php
/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue,ParentList};
use src\Security\{CsfrTokens,Randomizer};
use src\Interfaces\Requester;
use bin\Requester\HttpRequester;


/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit; }
/* -------------------------------------------------------- */

try {
//
    $oReg = WbAdaptor::getInstance();
    $oDb  = $oReg->getDatabase();
    $oRequest = $oReg->getRequester();
    $oTrans   = $oReg->getTranslate();
    $oApp = $oReg->getApplication();
//
    $sAppUrl = $oReg->AppUrl;
    $sAddonName = \basename(__DIR__);
    $sAddonRel = '/modules/'.$sAddonName.'/';
    $sAddonPath = $oReg->AppPath.$sAddonRel;
    $sAddonUrl = $ModuleUrl = $oReg->AppUrl.'modules/'.$sAddonName.'/';
//    $ModulePath = $oReg->AppPath.'/modules/'.$sAddonName.'/';
    $sAddonThemeUrl = $sAddonUrl.'templates/default/';
    $sAbsAddonPath = $oReg->AppPath.'modules/'.$sAddonName.'/';
    $sAbsAddonThemeRel = '/modules/'.$sAddonName.'/themes/default';
    $sPattern = "/^(.*?\/)modules\/.*$/";
    $sAppPath = preg_replace ($sPattern, "$1", $sAddonPath, 1 );

//
    $sFtan      = SecureTokens::getFTAN();
    $sFtanQuery = $sFtan['name'].'='.$sFtan['value'];
    // load module language file
    if (\is_readable($sAbsAddonPath.'languages/EN.php')) {require($sAbsAddonPath.'/languages/EN.php');}
    if (\is_readable($sAbsAddonPath.'languages/'.DEFAULT_LANGUAGE.'.php')) {require($sAbsAddonPath.'/languages/'.DEFAULT_LANGUAGE.'.php');}
    if (\is_readable($sAbsAddonPath.'languages/'.LANGUAGE.'.php')) {require($sAbsAddonPath.'/languages/'.LANGUAGE.'.php');}

    $oTrans->enableAddon('modules\\'.\basename(__DIR__));
//
    require($oReg->AppPath.'framework/functions.php');

    $oPages = $database->query("SELECT * FROM `".TABLE_PREFIX."pages` WHERE `page_id` = '$page_id'");
    $aPages = $oPages->fetchRow(MYSQLI_ASSOC);
    $page_created = $aPages['link'];
    $dateview = 0;

    $sSql = 'SELECT * FROM `'.TABLE_PREFIX.'mod_concert_settings`'
          . 'WHERE `section_id` = '.$section_id.'';
    if (($oConcert = $database->query($sSql))) {
      if (($oConcert->numRows()>0)){
            $aConcert = $oConcert->fetchRow(MYSQLI_ASSOC);
            $dateview = $aConcert['dateview'];
        }
    }

    $sql  = 'SELECT * FROM `'.TABLE_PREFIX.'mod_concert_dates` '
          . 'WHERE `section_id` = '.(int)$section_id.' '
          . 'ORDER BY `concert_date` DESC';
    $query_dates = $database->query($sql);

?>
<article class="concert-block w3-container">
    <h2 class="w3-hide">&nbsp;</h2>
    <table class="w3-table w3-card ">
        <tbody>
        <tr>
          <td class="w3-half">
              <form id="concert-modify" action="<?php echo $sAddonUrl; ?>modify_concert.php" method="post">
                  <input type="hidden" name="page_id" value="<?php echo $page_id; ?>" />
                  <input type="hidden" name="section_id" value="<?php echo $section_id; ?>" />
                  <input type="hidden" name="concert_id" value="0"/>
                  <input type="hidden" name="<?= $sFtan['name'];?>" value="<?= $sFtan['value'];?>" />
                  <button class="w3-btn w3-btn-default w3-blue-wb w3-hover-green w3-medium w3-btn-min-width w3-width-98" type="submit" name="save-type" value="create"><?php echo $MOD_CONCERT['ADDCONCERT']; ?></button>
              </form>
          </td>
          <td class="w3-half">
              <form id="concert-settings" action="<?php echo $sAddonUrl; ?>modify_settings.php" method="post">
                  <input type="hidden" name="page_id" value="<?php echo $page_id; ?>" />
                  <input type="hidden" name="section_id" value="<?php echo $section_id; ?>" />
                  <input type="hidden" name="<?= $sFtan['name'];?>" value="<?= $sFtan['value'];?>" />
                  <button class="w3-btn w3-btn-default w3-blue-wb w3-hover-green w3-medium w3-btn-min-width w3-width-98" type="submit" name="settings_id" value="" ><?php echo $TEXT['SETTINGS']; ?></button>
              </form>
          </td>
        </tr>
        </tbody>
    </table>

    <div class="w3-display-container" style="position: relative;height: 60px;">
        <div class="w3-col w3-display-left ">
            <h2><?php echo $MOD_CONCERT['CONCERTS'] ?></h2>
        </div>
        <div class="w3-col w3-display-middle ">&nbsp;</div>
        <div class="w3-col w3-display-right" style="margin: 8px 0;">
            <div class="input-container">
              <i class="fa fa-search icon w3-blue-wb">&#160;</i>
              <input data-sec="<?= $section_id;?>" id="concertInput" class="input-field w3-input w3-border" placeholder="Search" type="text" value="" style="width:auto;"/>
            </div>
        </div>
    </div>

    <form id="concert-overview" action="<?php echo $sAddonUrl; ?>modify_concert.php" method="post">
        <input type="hidden" name="page_id" value="<?php echo $page_id; ?>" />
        <input type="hidden" name="section_id" value="<?php echo $section_id; ?>" />
        <input type="hidden" name="<?= $sFtan['name'];?>" value="<?= $sFtan['value'];?>" />

        <table class="concert-table w3-table-all w3-strip scroll w3-border-0">
          <caption class="w3-hide w3-xlarge w3-text-blue-wb w3-left w3-margin"><?php echo $MOD_CONCERT['CONCERTS'] ?></caption>
          <thead class="w3-border-top">
            <tr>
              <th style="text-align: right;">ID</th>
              <th style="text-align: center;">Edit</th>
              <th>Datum</th>
              <th>Veranstaltung</th>
              <th>Ort</th>
              <th>löschen</th>
            </tr>
          </thead>
          <tbody id="concertResult_<?= $section_id;?>">
<?php
  if ($query_dates->numRows() > 0) {
    while(($result = $query_dates->fetchRow(MYSQLI_ASSOC))) {
      $alt2date=$result['concert_date'];
      $sConcertIdKey = $result['concert_id'];
      $sUrl = $oReg->AppUrl.'/modules/concert/delete_concert.php?page_id='.$page_id.'&amp;section_id='.$section_id.'&amp;concert_id='.$sConcertIdKey;
      $aList = $admin->convertToArray($alt2date);
      list($a2year, $a2month, $a2day) = $aList;
      $ydash="-";
      $ydot=".";
      if ($a2year=="2000"){
        $a2year="";
        $alt2date=substr($alt2date,5,5);
        $ydash="";
        $ydot="";
      }
      if ($dateview == 1 ) {
        $altdate=$a2day.".".$a2month.$ydot.$a2year;
      } elseif ($dateview == 2 ) {
        $altdate=$a2month."-".$a2day.$ydash.$a2year;
      } else {
        $altdate=$alt2date;
      }
?>
    <tr>
      <td style="text-align: right;"><?= $sConcertIdKey;?></td>
      <td style="text-align: center;">
        <button class="w3-pointer w3-transparent w3-border-0" name="concert_id" value="<?php echo $sConcertIdKey; ?>" title="<?php echo $TEXT['MODIFY']; ?>">
            <img src="<?php echo $oReg->AppUrl.$sAbsAddonThemeRel; ?>/img/16/modify.png" alt="<?php echo $TEXT['MODIFY']; ?>" />
        </button>
      </td>
      <td style="padding-left: 5px;">
        <?php echo $altdate ?>
      </td>
      <td style="padding-left: 5px;">
        <?php echo $result['concert_name']  ?>
      </td>
      <td style="padding-left: 5px;">
        <?php echo $result['concert_club'];  ?>
      </td>
      <td style="text-align: center;" >
        <a class="w3-pointer w3-transparent w3-border-0" onclick="return confirm_link('<?php echo $TEXT['ARE_YOU_SURE'];?>','<?=$sUrl;?>');" title="<?php echo $TEXT['DELETE']; ?>'">
            <img src="<?php echo $oReg->AppUrl.$sAbsAddonThemeRel; ?>/img/16/delete.png" alt="<?php echo $TEXT['DELETE']; ?>" />
        </a>
      </td>
    </tr>
<?php
  } // end while
} else {
?>
  <tr class="w3-white">
    <td colspan="6" class="w3-large"><?php echo $MOD_CONCERT['NO_ENTRY'];?></td>
  </tr>
<?php } ?>
    </tbody>
  </table>
  </form>
</article>

<?php
} catch (\Exception $ex) {
    $sErrMsg = PreCheck::xnl2br(\sprintf('[%03d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}
