<?php
/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

use bin\WbAdaptor;
use addon\news\NewsLib;
use bin\helpers\PreCheck;
use bin\helpers\ParentList;

if (!defined('SYSTEM_RUN') ){ require( dirname(dirname((__DIR__))).'/config.php' );}

    $oReg = WbAdaptor::getInstance();
    $database = $oReg->getDatabase();
    $oRequest = $oReg->getRequester();
try {

// suppress to print the header, so no new FTAN will be set
//$admin_header = false;
// Tells script to update when this page was last updated
    $update_when_modified = false;
// show the info banner
    $print_info_banner = true;
// Include WB admin wrapper script
    require(WB_PATH.'/modules/admin.php');

//    $requestMethod = strtoupper($_SERVER['REQUEST_METHOD']);
//    $aRequestVars  = (isset(${'_'.$requestMethod}) ? ${'_'.$requestMethod} : $_REQUEST);

    $sAddonName   = basename(__DIR__);
    $sAddonRel    = '/modules/'.$sAddonName;
    $sAddonUrl    = WB_URL.$sAddonRel;
    $sAddonPath   = WB_PATH.$sAddonRel;
    $sPattern = "/^(.*?\/)modules\/.*$/";
    $sAppPath = preg_replace ($sPattern, "$1", $sAddonPath, 1 );

    $sLocalDebug  = (is_readable($sAddonPath.'/.setDebug'));
    $sSecureToken = (!is_readable($sAddonPath.'/.setToken'));
    $sPHP_EOL     = ($sLocalDebug ? "\n" : '');
    $sChecked     = ' checked="checked"';
    $sSelected    = ' selected="selected"';

    $aMsg = [];
    $aMessage = null;
    $sSectionIdPrefix = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != 'none' )  ? '#'.SEC_ANCHOR.$section_id : '' );
    $sAdminLinkRel = ADMIN_DIRECTORY.'/pages/modify.php?page_id='.$page_id.$sSectionIdPrefix;
    $sBacklink     = WB_URL.'/'.$sAdminLinkRel;

    $sAddonBackUrl = $sBacklink;

// check if module language file exists for the language set by the user (e.g. DE, EN)
    if (is_readable($sAddonPath.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
    if (is_readable($sAddonPath.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
    if (is_readable($sAddonPath.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

    $oLang = Translate::getInstance();
    $oLang->enableAddon('modules\\'.basename(__DIR__));
/* ------------------------ */

    if (!(\bin\SecureTokens::checkFTAN()) && $sSecureToken) {
        $aMessage = sprintf($MESSAGE['GENERIC_SECURITY_ACCESS']);
        throw new \Exception ($aMessage);
    }

    $concert_id = ($oRequest->getParam('concert_id') ?? 0);

    $sFtan      = \bin\SecureTokens::getFTAN();
    $sFtanQuery = $sFtan['name'].'='.$sFtan['value'];

// Get Settings from database
    $aSql[0] = "SELECT * FROM `".TABLE_PREFIX."mod_concert_settings` WHERE `section_id` = '$section_id'";
    if (($oSettings = $database->query($aSql[0]))){
        if (!($fetch_page_content = $oSettings->fetchRow(MYSQLI_ASSOC))){
            $aMessage = sprintf("Missing Settings Entry for section %d\n%s",$section_id,$database->get_error());
            throw new \Exception ($aMessage);
        }
    }
    $dateview = $fetch_page_content['dateview'];

// Get Data from database
    $aSql[1] = 'SELECT * FROM `'.TABLE_PREFIX.'mod_concert_dates` '
            . 'WHERE `concert_id` = '.(int)$concert_id;
    if (!($oRes = $database->query($aSql[1]))){
        $aMessage = sprintf($database->get_error());
        throw new \Exception ($aMessage);
    }

    if (!($fetch_content = $oRes->fetchRow(MYSQLI_ASSOC))){
//        $concert_date = date("Y-m-d");
//        $aThisDate = $admin->convertToArray($this_date);
        if ($concert_id){
            $aMessage = sprintf('[%04d] Something went wrong with id = %04d ',__LINE__,$concert_id);
            \trigger_error($aMessage, E_USER_NOTICE);
        }
        $concert_id = 0;
    } else {
//        $concert_date = $fetch_content['concert_date'];
    }
    $concert_name = ($fetch_content['concert_name'] ?? '');
    $concert_date = ($fetch_content['concert_date'] ?? date("Y-m-d"));
    $concert_place = ($fetch_content['concert_place'] ?? '');
    $concert_club = ($fetch_content['concert_club'] ?? '');
    $concert_time = ($fetch_content['concert_time'] ?? '');
    $concert_price = ($fetch_content['concert_price'] ?? '');
    $concert_desc = ($fetch_content['concert_desc'] ?? '');

    if (!empty($concert_desc)){
        $concert_desc = OutputFilterApi('ReplaceSysvar', $concert_desc);
        $concert_desc = \htmlspecialchars($concert_desc);
    }

    $aThisDate = $admin->convertToArray($concert_date);
    switch ($dateview):
        case '1':
        case '2':
        default:
            list($year, $month, $day) = $aThisDate;
    endswitch;

    if (is_array($aThisDate)) {
        $minYear = '2011';
        $maxYear = '2038';
        $maxDays = cal_days_in_month(CAL_GREGORIAN, $month, $year);;
        $aYears  = [];
        $aMonths = [];
        $aDays   = [];
//
        for($y = $minYear; $y <= $maxYear; $y++ ){
          $aYears[$y] = (($y == $year) ? $sSelected : '');
        }
//
        for($m = 1; $m <= 12; $m++ ){
          $tmp = sprintf('%02d',$m);
          $aMonths[$tmp] = (($tmp==$month) ? $sSelected : '');
        }
//
        for($d = 1; $d <= $maxDays; $d++ ){
          $tmp = sprintf('%02d',$d);
          $aDays[$tmp] = (($tmp==$day) ? $sSelected : '');
        }
    }

}catch (\Exception $ex) {
    $admin->print_header('',false);
    $sErrMsg = PreCheck::xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}
    $sShowId = ($concert_id ? ' ('.$concert_id.') ' : '');
    $sTitle = ($concert_id ? $MOD_CONCERT['MODIFY_CONCERT'] : $MOD_CONCERT['ADD_CONCERT']).$sShowId;
?>
<article class="concert-block w3-margin modify-concert">

<h2><?php echo $sTitle; ?></h2>
    <form id="modify-concert" action="<?php echo WB_URL; ?>/modules/concert/save_concert.php" method="post" style="margin: 0;">
        <input type="hidden" name="section_id" value="<?php echo $section_id; ?>">
        <input type="hidden" name="page_id" value="<?php echo $page_id; ?>">
        <input type="hidden" name="concert_id" value="<?php echo $concert_id; ?>">
        <input type="hidden" name="dateview" value="<?= $dateview;?>"/>
        <input type="hidden" name="save-type" value="<?php echo (($concert_id!=0) ? 'update' : 'insert'); ?>" />
        <input type="hidden" name="<?= $aFtan['name'];?>" value="<?= $aFtan['value'];?>"/>

    <table class="w3-table  concert_table">
    <tbody>
      <tr>
        <td class="setting_name">
          <?php echo $MOD_CONCERT['INSERTDATE']; ?> :
        </td>
        <td class="setting_value">
            <div class="w3-bar">
                <label class="w3-padding w3-bar-item"><?= $MOD_CONCERT['DAY'];?>:</label>
                <select class="w3-select w3-bar-item  w3-width-6" name="day" id="day-view">
<?php foreach($aDays as $index => $select){ ?>
                <option value="<?= $index;?>"<?php echo $select;?> id="day_<?= $index;?>"><?= $index;?></option>
<?php } ?>
                </select>
                <label class="w3-padding w3-bar-item"><?= $MOD_CONCERT['MONTH'];?>:</label>
                <select class="w3-select w3-bar-item w3-width-12" name="month" id="month-view">
<?php foreach($aMonths as $index => $select){ ?>
                <option value="<?= $index;?>" <?php echo $select;?> id="month_<?= $index;?>"><?= $MOD_CONCERT['MONTHS'][$index];?></option>
<?php } ?>
                </select>
                <label class="w3-padding w3-bar-item"><?= $MOD_CONCERT['YEAR'];?>:</label>
                <select class="w3-select w3-bar-item w3-width-8" name="year" id="year-view">
<?php foreach($aYears as $index => $select){ ?>
                <option value="<?= $index;?>"<?php echo $select;?> id="year_<?= $index;?>"><?= $index;?></option>
<?php } ?>
                </select>
                <label id="concert_day-view" class="w3-padding w3-bar-item"><?= $concert_date;?></label>
            </div>
        </td>
      <tr>
        <td class="setting_name"><label>Information:</label></td>
        <td class="setting_value">
            <label id="output"></label>
        </td>
      </tr>

      </tr>
          <tr>
        <td class="setting_name">
          <?php echo $MOD_CONCERT['ENTER_NAME']; ?> :
        </td>
        <td class="setting_value">
          <input class="w3-input" name="concert_name" style="width: 66%;" value="<?php echo $concert_name; ?>" />
        </td>
      </tr>
      <tr>
        <td class="setting_name">
          <?php echo $MOD_CONCERT['ENTER_PLACE']; ?> :
        </td>
        <td class="setting_value">
          <input class="w3-input" name="concert_place" style="width: 66%;" value="<?php echo $concert_place; ?>" />
        </td>
      </tr>
      <tr>
        <td class="setting_name">
          <?php echo $MOD_CONCERT['ENTER_CLUB']; ?> :
        </td>
        <td class="setting_value">
          <input class="w3-input" name="concert_club" style="width: 66%;" value="<?php echo $concert_club; ?>" />
        </td>
      </tr>
        <tr>
        <td class="setting_name">
          <?php echo $MOD_CONCERT['ENTER_TIME']; ?> :
        </td>
        <td>
          <input class="w3-input" name="concert_time" style="width: 66%;" value="<?php echo $concert_time; ?>" />
        </td>
      </tr>
        <tr>
        <td class="setting_name">
          <?php echo $MOD_CONCERT['ENTER_PRICE']; ?> :
        </td>
        <td>
          <input class="w3-input" name="concert_price" style="width: 60%%;" value="<?php echo $concert_price; ?>" />
        </td>
      </tr>
    </tbody>
    </table>

<table class="w3-table concert_table">
    <tbody>
        <tr>
          <td class="setting_-value">
<?php
            $content = ($fetch_content['concert_desc'] ?? '');
            $content = OutputFilterApi('ReplaceSysvar', $content);
            $content = \htmlspecialchars($content);
            $name = 'content';
            if (!isset($wysiwyg_editor_loaded)) {
                $wysiwyg_editor_loaded=true;
                if (!\defined('WYSIWYG_EDITOR') || WYSIWYG_EDITOR=="none" || !\file_exists(WB_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php')) {
                    function show_wysiwyg_editor($name,$id,$content,$width,$height) {
                        echo '<textarea name="'.$name.'" id="'.$id.'" style="width: '.$width.'; height: '.$height.';">'.$content.'</textarea>';
                    }
                } else {
                    $id_list = ["concert_desc"];
                    require(WB_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php');
                }
            }
            show_wysiwyg_editor("concert_desc","concert_desc",$content,"100%","400px");
?>
          </td>
        </tr>
    </tbody>
</table>

        <table class="w3-table">
        <tbody>
          <tr>
            <td>
                <input class="w3-btn w3-blue-wb w3-hover-green w3-medium w3-btn-min-width" name="save" type="submit" value="<?php echo $TEXT['SAVE']; ?>" style="margin-top: 5px;"/>
                <input class="w3-btn w3-blue-wb w3-hover-green w3-medium w3-btn-min-width" name="save-close" type="submit" value="<?php echo $TEXT['SAVE_BACK']; ?>" style="margin-top: 5px;"/>
            </td>
            <td>
                <input class="w3-btn w3-blue-wb w3-hover-red w3-medium w3-btn-min-width url-close w3-right" type="button" value="<?php echo $TEXT['CLOSE']; ?>" data-overview="<?php echo $sAdminLinkRel; ?>" />
            </td>
          </tr>
        </tbody>
        </table>
    </form>
  </article>


<?php
// Print admin footer
$admin->print_footer();

