<?php
/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

use bin\WbAdaptor;
use addon\news\NewsLib;
use bin\helpers\PreCheck;
use bin\helpers\ParentList;

if (!defined('SYSTEM_RUN') ){ require( dirname(dirname((__DIR__))).'/config.php' );}

    $oReg = WbAdaptor::getInstance();
    $database = $oReg->getDatabase();

try {

// suppress to print the header, so no new FTAN will be set
//$admin_header = false;
// Tells script to update when this page was last updated
    $update_when_modified = false;
// show the info banner
    $print_info_banner = true;
// Include WB admin wrapper script
    require(WB_PATH.'/modules/admin.php');

    $oRequest = ($oRequest ?? \bin\requester\HttpRequester::getInstance());

//    $requestMethod = strtoupper($_SERVER['REQUEST_METHOD']);
//    $aRequestVars  = (isset(${'_'.$requestMethod}) ? ${'_'.$requestMethod} : $_REQUEST);

    $sAddonName   = basename(__DIR__);
    $sAddonRel    = '/modules/'.$sAddonName;
    $sAddonUrl    = WB_URL.$sAddonRel;
    $sAddonPath   = WB_PATH.$sAddonRel;
    $sLocalDebug  = (is_readable($sAddonPath.'/.setDebug'));
    $sSecureToken = (!is_readable($sAddonPath.'/.setToken'));
    $sPHP_EOL     = ($sLocalDebug ? "\n" : '');
    $sChecked     = ' checked="checked"';
    $sSelected    = ' selected="selected"';

    $aMsg = [];
    $sSectionIdPrefix = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != 'none' )  ? '#'.SEC_ANCHOR.$section_id : '' );
    $sAdminLinkRel = ADMIN_DIRECTORY.'/pages/modify.php?page_id='.$page_id.$sSectionIdPrefix;
    $sBacklink     = WB_URL.'/'.$sAdminLinkRel;

    $sAddonBackUrl = $sBacklink;

// include core functions of WB 2.7 to edit the optional module CSS files (frontend.css, backend.css)
    if (!function_exists('edit_module_css')) {include(WB_PATH .'/framework/module.functions.php');}

// check if module language file exists for the language set by the user (e.g. DE, EN)
    if (is_readable($sAddonPath.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
    if (is_readable($sAddonPath.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}
    if (is_readable($sAddonPath.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}

    $oLang = Translate::getInstance();
    $oLang->enableAddon('modules\\'.basename(__DIR__));
/* ------------------------ */

    if (!(\bin\SecureTokens::checkFTAN()) && $sSecureToken) {
        $sErrorMessage = sprintf($MESSAGE['GENERIC_SECURITY_ACCESS']);
        throw new \Exception ($sErrorMessage);
    }

    $sFtan      = \bin\SecureTokens::getFTAN();
    $sFtanQuery = $sFtan['name'].'='.$sFtan['value'];

    $sql  = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_concert_settings` '
    . 'WHERE `section_id`='.$section_id.'';
    if (!($iNumRow = $database->get_one($sql))){
        include __DIR__.'/add.php';
    }
    $query_page_content = $database->query("SELECT * FROM `".TABLE_PREFIX."mod_concert_settings` WHERE `section_id` = '$section_id'");
    $fetch_page_content = $query_page_content->fetchRow();

    $ccheader = stripslashes($fetch_page_content['header_data']);
    $ccfooter = stripslashes($fetch_page_content['footer_data']);
    $ccloop   = stripslashes($fetch_page_content['ccloop']);

}catch (\Exception $ex) {
    $admin->print_header('',false);
    $sErrMsg = PreCheck::xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}

?>
<article class="concert-block w3-margin ">
<h2><?php echo $MOD_CONCERT['SETTINGS']; ?></h2>
<?php
// include the button to edit the optional module CSS files
// Note: CSS styles for the button are defined in backend.css (div class="mod_moduledirectory_edit_css")
// Place this call outside of any <form></form> construct!!!
if(function_exists('edit_module_css')) {edit_module_css('concert');}
?>

    <form name="edit" action="<?php echo WB_URL; ?>/modules/concert/save_set.php" method="post" style="margin: 0;">
        <input type="hidden" name="page_id" value="<?php echo $page_id; ?>"/>
        <input type="hidden" name="section_id" value="<?php echo $section_id; ?>"/>
        <input type="hidden" name="<?= $aFtan['name'];?>" value="<?= $aFtan['value'];?>"/>

        <table class="w3-table concert_table w3-border-bottom">
        <tbody>
          <tr>
            <td class="setting_name">
              <?php echo $MOD_CONCERT['DISPDETAILEDVIEW']; ?> :
            </td>
            <td class="setting_value">
               <div>
                    <label class="radio" for="detailed_view-1">
                        <input id="detailed_view-1" type="radio" name="detailed_view" value="1"<?php echo (($fetch_page_content['detailed_view']) ? $sChecked : '');?> />
                        <span><?php echo $TEXT['YES']; ?></span>
                    </label>
                    <label class="radio" for="detailed_view-0">
                        <input id="detailed_view-0" type="radio" name="detailed_view" value="0"<?php echo ((!$fetch_page_content['detailed_view']) ? $sChecked : '');?> />
                        <span><?php echo $TEXT['NO']; ?></span>
                    </label>
                </div>
            </td>
          </tr>
          <tr>
            <td class="setting_name">
              <?php echo $MOD_CONCERT['DISPUPCOMINGVIEW']; ?> :
            </td>
            <td class="setting_value">
               <div>
                    <label class="radio" for="upcoming_view-1">
                        <input id="upcoming_view-1" type="radio" name="upcoming_view" value="1"<?php echo (($fetch_page_content['upcoming_view']) ? $sChecked : '');?> />
                        <span><?php echo $TEXT['YES']; ?></span>
                    </label>
                    <label class="radio" for="upcoming_view-0">
                        <input id="upcoming_view-0" type="radio" name="upcoming_view" value="0"<?php echo ((!$fetch_page_content['upcoming_view']) ? $sChecked : '');?> />
                        <span><?php echo $TEXT['NO']; ?></span>
                    </label>
                </div>
            </td>
          </tr>
            <tr>
            <td class="setting_name">
              <?php echo $MOD_CONCERT['UPCOMINGNUM']; ?> :
            </td>
            <td class="setting_value">
              <input class="w3-input" type="text" name="upcoming_num" id="upcoming_num" value="<?php echo $fetch_page_content['upcoming_num']; ?>" />
            </td>
          </tr>
          <tr>
            <td class="setting_name">
              <?php echo $MOD_CONCERT['DISPPREVIOUSVIEW']; ?> :
            </td>
            <td class="setting_value">
               <div>
                    <label class="radio" for="previous_view-1">
                        <input id="previous_view-1" type="radio" name="previous_view" value="1"<?php echo (($fetch_page_content['previous_view']) ? $sChecked : '');?> />
                        <span><?php echo $TEXT['YES']; ?></span>
                    </label>
                    <label class="radio" for="previous_view-0">
                        <input id="previous_view-0" type="radio" name="previous_view" value="0"<?php echo ((!$fetch_page_content['previous_view']) ? $sChecked : '');?> />
                        <span><?php echo $TEXT['NO']; ?></span>
                    </label>
                </div>
            </td>
          </tr>
          <tr>
            <td class="setting_name">
              <?php echo $MOD_CONCERT['PREVIOUSNUM']; ?> :
            </td>
            <td class="setting_value">
              <input class="w3-input" type="text" name="previous_num" id="previous_num" value="<?php echo $fetch_page_content['previous_num']; ?>" />
            </td>
          </tr>
          <tr>
            <td class="setting_name">
              <?php echo $TEXT['DATE_FORMAT']; ?> :
            </td>
            <td class="setting_value">
              <select name="dateview_form" class="w3-select w3-border">
                  <option value ="0" <?php if ($fetch_page_content['dateview'] == 0) { echo "selected"; } ?> ><?php echo $MOD_CONCERT['YEAR']."-".$MOD_CONCERT['MONTH']."-".$MOD_CONCERT['DAY']; ?></option>
                  <option value ="1" <?php if ($fetch_page_content['dateview'] == 1) { echo "selected"; } ?> ><?php echo $MOD_CONCERT['DAY'].".".$MOD_CONCERT['MONTH'].".".$MOD_CONCERT['YEAR']; ?></option>
                  <option value ="2" <?php if ($fetch_page_content['dateview'] == 2) { echo "selected"; } ?> ><?php echo $MOD_CONCERT['MONTH']."-".$MOD_CONCERT['DAY']."-".$MOD_CONCERT['YEAR']; ?></option>
              </select>
            </td>
          </tr>
            <tr>
              <td class="setting_name"><?php echo $MOD_CONCERT['LINKDATE']; ?> :</td>
                <td class="setting_value">
                    <div>
                        <label class="radio" for="date_link-1">
                            <input id="date_link-1" type="radio" name="date_link" value="1"<?php echo (($fetch_page_content['date_link']) ? $sChecked : '');?> />
                            <span><?php echo $TEXT['YES']; ?></span>
                        </label>
                        <label class="radio" for="date_link-0">
                            <input id="date_link-0" type="radio" name="date_link" value="0"<?php echo ((!$fetch_page_content['date_link']) ? $sChecked : '');?> />
                            <span><?php echo $TEXT['NO']; ?></span>
                        </label>
                    </div>
                </td>
            </tr>
            <tr>
              <td class="setting_name"> <?php echo $MOD_CONCERT['TOGGLE']; ?> :</td>
              <td class="setting_value">
                  <div>
                      <label class="radio" for="toggle-1">
                          <input id="toggle-1" type="radio" name="toggle" value="1"<?php echo (($fetch_page_content['toggle']) ? $sChecked : '');?> />
                          <span><?php echo $TEXT['YES']; ?></span>
                      </label>
                      <label class="radio" for="toggle-0">
                          <input id="toggle-0" type="radio" name="toggle" value="0"<?php echo ((!$fetch_page_content['toggle']) ? $sChecked : '');?> />
                          <span><?php echo $TEXT['NO']; ?></span>
                      </label>
                  </div>
              </td>
            </tr>
          <tr>
            <td class="setting_name">
              <?php echo $MOD_CONCERT['CCHEADER']; ?> :
            </td>
            <td class="setting_value">
                <textarea name="ccheader" style="width: 98%; height: 140px;"><?php echo $ccheader; ?></textarea>
            </td>
          </tr>
            <tr>
            <td class="setting_name">
              <?php echo $MOD_CONCERT['CCLOOP']; ?> :
            </td>
            <td class="setting_value">
                <textarea name="ccloop" style="width: 98%; height: 140px;"><?php echo $ccloop; ?></textarea>
                <span><?php echo $MOD_CONCERT['TO_USE']; ?>: [NAME], [DATE], [PLACE], [CLUB], [TIME], [PRICE], [INFO]</span>
            </td>
          </tr>
          <tr>
            <td class="setting_name">
              <?php echo $MOD_CONCERT['CCFOOTER']; ?> :
            </td>
            <td class="setting_value">
                <textarea name="ccfooter" style="width: 98%; height: 140px;"><?php echo $ccfooter; ?></textarea>
            </td>
          </tr>
        </tbody>
        </table>

        <table class="w3-table">
        <tbody>
          <tr>
            <td>
                <input class="w3-btn w3-blue-wb w3-hover-green w3-medium w3-btn-min-width" name="save" type="submit" value="<?php echo $TEXT['SAVE']; ?>" style="margin-top: 5px;"/>
                <input class="w3-btn w3-blue-wb w3-hover-green w3-medium w3-btn-min-width" name="save-close" type="submit" value="<?php echo $TEXT['SAVE_BACK']; ?>" style="margin-top: 5px;"/>
            </td>
            <td>
                <input class="w3-btn w3-blue-wb w3-hover-red w3-medium w3-btn-min-width url-close w3-right" type="button" value="<?php echo $TEXT['CLOSE']; ?>" data-overview="<?php echo $sAdminLinkRel; ?>" />
            </td>
          </tr>
        </tbody>
        </table>
    </form>
</article>

<?php

// Print admin footer
$admin->print_footer();

