<?php
/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue,ParentList};
use src\Security\{CsfrTokens,Randomizer};
use src\Interfaces\Requester;
use bin\Requester\HttpRequester;

    $sAddonPath = str_replace(['\\','//'],'/',(__DIR__)).'/'; $iSteps = 2;
    $sPattern = "/^(.*?\/)modules\/.*$/";
    $sAppPath = preg_replace ($sPattern, "$1", $sAddonPath, 1 );

    if (!\defined('SYSTEM_RUN')) {require ($sAppPath.'config.php');}

try {

    $sAddonName = \basename(__DIR__);
    $sAddonRel  = '/modules/'.$sAddonName;
    $sAddonUrl  = WB_URL.$sAddonRel;
    $sAddonPath = WB_PATH.$sAddonRel;
    $sLocalDebug  = (is_readable($sAddonPath.'/.setDebug'));
    $sSecureToken = (!is_readable($sAddonPath.'/.setToken'));
    $sPHP_EOL     = ($sLocalDebug ? "\n" : '');

    $admin_header = true;
    // Tells script to update when this page was last updated
    $update_when_modified = true;
    // Include WB admin wrapper script
    require(WB_PATH.'/modules/admin.php');

    $oReg     = Wbadaptor::getInstance();
    $oDb      = $oReg->getDatabase();
    $oRequest = $oReg->getRequester();
    $oTrans   = $oReg->getTranslate();
    $database = $oReg->getDatabase();
    $oApp     = $oReg->getApplication();

    $sSectionIdPrefix = (\defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != 'none' )  ? '#'.SEC_ANCHOR.$section_id : '' );
    $sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;
    $sBackModifyLink = $sAddonUrl.'/modify_concert.php?page_id='.$page_id.'&section_id='.$section_id.'&'.$sFtanQuery;
    $sBacklink = ($oRequest->getParam('save-close') ? $sBacklink.'#'.$sSectionIdPrefix.$section_id : $sBackModifyLink );
    $sAddonBackUrl = $sBacklink;

    $sGetOldSecureToken = SecureTokens::checkFTAN();
    $aFtan = SecureTokens::getFTAN();
    $sFtanQuery = $aFtan['name'].'='.$aFtan['value'];

    $oTrans = \Translate::getInstance();
    $oTrans->enableAddon('modules\\'.$sAddonName);

    if (!$sGetOldSecureToken && $sSecureToken){
        $aMessage = \sprintf($MESSAGE['GENERIC_SECURITY_ACCESS']);
        throw new \Exception ($aMessage);
    }

// Validate all fields
    $aVars = $oRequest->getParamNames();
    foreach ($aVars as $sName) {
        $aRequestVars[$sName] = $oRequest->getParam($sName);
        ${$sName} = $aRequestVars[$sName];
    }
    $saveType   = $oRequest->getParam('save-type');

    if (empty($concert_name)) {
        $aMessage = sprintf('Missing title %s',$MESSAGE['GENERIC_FILL_IN_ALL']);
        throw new \Exception ($aMessage);
    } else {

/*
print '<pre class="mod-pre rounded" style="padding-left:0.9em;">'.PHP_EOL.'function <span>'.__FUNCTION__.'( '.''.' );</span>'.PHP_EOL.'Filename: <span>'.\basename(__FILE__).'</span>'.PHP_EOL.'Line: '.__LINE__.' -> <br /><br />'.PHP_EOL;
\print_r( $concert_name ); print PHP_EOL.'</pre>'.PHP_EOL; \flush (); // htmlspecialchars() ob_flush();;sleep(10); die();
*/

      $dateview     = 0; //column only accept Y-m-d
      $concert_desc = $admin->ReplaceAbsoluteMediaUrl($concert_desc);

    }
// send the posted date through mktime to get a correct date
    $sDateFormat = 'Y-m-d';
    switch ($dateview):
        case '1':
            $sDateFormat = 'd.m.Y';
            break;
        case '2':
            $sDateFormat = 'm.d.Y';
            break;
        default:
            $sDateFormat = 'Y-m-d';
    endswitch;

    $fulldate = date($sDateFormat, mktime(0, 0, 0, $month, $day, $year));
//  RL110204 - isset added
    if (isset($concert_date) && ($concert_date == $fulldate)) {
      $date = $concert_date;
    } else {
      $date = $fulldate;
    }

    $aSql = [];
    $order = new order(TABLE_PREFIX.'mod_concert_dates', 'position', 'concert_id', 'section_id');
    $sqlBodySet  = ''
              . '`page_id` ='.$page_id.''.$sPHP_EOL
              . ',`section_id` ='.$section_id.''.$sPHP_EOL
              . ',`concert_date` = \''.$database->escapeString($date).'\''.$sPHP_EOL
              . ',`concert_desc` = \''.$database->escapeString($concert_desc).'\''.$sPHP_EOL
              . ',`concert_name` = \''.$database->escapeString($concert_name).'\''.$sPHP_EOL
              . ',`concert_place` = \''.$database->escapeString($concert_place).'\''.$sPHP_EOL
              . ',`concert_club` = \''.$database->escapeString($concert_club).'\''.$sPHP_EOL
              . ',`concert_price` = \''.$database->escapeString($concert_price).'\''.$sPHP_EOL
              . ',`concert_time` = \''.$database->escapeString($concert_time).'\''.$sPHP_EOL;
//              . ',`` ='..''
//              . ',`` ='..''
    $aSql[1]  = ''
          . ',`modified_when` ='.time().''.$sPHP_EOL
          . ',`modified_by`   ='.$admin->getUserId().''.$sPHP_EOL;
    $aSql[2] = ($database->field_exists(TABLE_PREFIX.'mod_concert_dates','modified_when') ? $aSql[1] : '');

    if (($saveType == 'insert')){
        $sSql     = 'INSERT INTO `'.TABLE_PREFIX.'mod_concert_dates`  SET '.$sPHP_EOL;
        $aSql[1]  = ''
              . ',`modified_when` ='.time().''.$sPHP_EOL
              . ',`modified_by`   ='.$admin->getUserId().''.$sPHP_EOL
              . ',`created_when` ='.time().''.$sPHP_EOL
              . ',`created_by`   ='.$admin->getUserId().''.$sPHP_EOL;
        $aSql[2] = ($database->field_exists(TABLE_PREFIX.'mod_concert_dates','created_when') ? $aSql[1] : '');
        $sSqlWhere = '';
    } else {
        $sSql     = 'UPDATE `'.TABLE_PREFIX.'mod_concert_dates`  SET '.$sPHP_EOL;
        $sSqlWhere = ' WHERE `concert_id` = '.$concert_id.' ';
    }
    $sSqlAll = $sSql.$sqlBodySet.$aSql[2].$sSqlWhere;

    if (!($oRes = $database->query($sSqlAll))){
        $aMessage = \sprintf("%s \n %s",$sSqlAll,$database->get_error());
        throw new \Exception ($aMessage);
    } else {
        $concert_id = (($saveType == 'insert') ? $database->getLastInsertId() : $concert_id);
        $sBackModifyLink = $sAddonUrl.'/modify_concert.php?page_id='.$page_id.'&section_id='.$section_id.'&concert_id='.$concert_id.'&'.$sFtanQuery;
        $sBacklink = ($oRequest->getParam('save-close') ? $sBacklink.'#'.$sSectionIdPrefix.$section_id : $sBackModifyLink );
        $sAddonBackUrl = $sBacklink;
    }

// Check if there is a db error, otherwise say successful
    if($database->is_error()) {
       $aMessage = \sprintf('%s',$database->get_error());
       throw new \Exception ($aMessage);
//      $admin->print_error($database->get_error(), );
    }

} catch (\Exception $ex) {
    $sErrMsg = PreCheck::xnl2br(\sprintf('[%03d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}
    $order->get_new($concert_id);
    $sExtra = $concert_name .' ('.$concert_id.')';
    $aMessage = PreCheck::xnl2br(sprintf('%s %s ',$sExtra,$MESSAGE['PAGES_SAVED']));
    $admin->print_success($aMessage, $sAddonBackUrl);

// Print admin footer
    $admin->print_footer();

