<?php
/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue,ParentList};
use src\Security\{CsfrTokens,Randomizer};
use src\Interfaces\Requester;
use bin\Requester\HttpRequester;


    $sAddonPath = str_replace(['\\','//'],'/',(__DIR__)).'/'; $iSteps = 2;
    $sPattern = "/^(.*?\/)modules\/.*$/";
    $sAppPath = preg_replace ($sPattern, "$1", $sAddonPath, 1 );

    if (!\defined('SYSTEM_RUN')) {require ($sAppPath.'config.php');}

try {

    $sAddonName = \basename(__DIR__);
    $sAddonRel  = '/modules/'.$sAddonName;
    $sAddonUrl  = WB_URL.$sAddonRel;
    $sAddonPath = WB_PATH.$sAddonRel;
    $sLocalDebug  = (is_readable($sAddonPath.'.setDebug'));
    $sSecureToken = (!is_readable($sAddonPath.'.setToken'));
    $sPHP_EOL     = ($sLocalDebug ? "\n" : '');

    $admin_header = true;
    // Tells script to update when this page was last updated
    $update_when_modified = true;
    // Include WB admin wrapper script
    require(WB_PATH.'/modules/admin.php');
    $msg = [];
    $oReg = WbAdaptor::getInstance();
    $oRequest = $oReg->getRequester();
    $database = $oReg->getDatabase();

    $sSectionIdPrefix = (\defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != 'none' )  ? '#'.SEC_ANCHOR.$section_id : '' );
    $sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;
    $sBackSettingsLink = $sAddonUrl.'/modify_settings.php?page_id='.$page_id.'&section_id='.$section_id.'&'.$sFtanQuery;
    $sBacklink = ($oRequest->getParam('save-close') ? $sBacklink.'#'.$sSectionIdPrefix.$section_id : $sBackSettingsLink );
    $sAddonBackUrl = $sBacklink;

    $sGetOldSecureToken = SecureTokens::checkFTAN();
    $aFtan = SecureTokens::getFTAN();
    $sFtanQuery = $aFtan['name'].'='.$aFtan['value'];

    $oTrans = \Translate::getInstance();
    $oTrans->enableAddon('modules\\'.$sAddonName);

    if (!$sGetOldSecureToken){
        $aMessage = \sprintf($MESSAGE['GENERIC_SECURITY_ACCESS']);
        throw new \Exception ($aMessage);
    }
// This code removes any php tags
    $header_data = (addslashes($aRequestVars['ccheader']) ?? '');
    $footer_data = (addslashes($aRequestVars['ccfooter']) ?? '');
    $ccloop = (addslashes($aRequestVars['ccloop']) ?? '');
    $detailed_view = ($aRequestVars['detailed_view'] ?? 1);
    $upcoming_view = ($aRequestVars['upcoming_view'] ?? 0);
    $previous_view = ($aRequestVars['previous_view'] ?? 0);
    $previous_num = addslashes($aRequestVars['previous_num']);
    $upcoming_num = addslashes($aRequestVars['upcoming_num']);
    $dateview = $aRequestVars['dateview_form'];
    $date_link = $aRequestVars['date_link'];
    $toggle = $aRequestVars['toggle'];

    if (empty($header_data)) {
        $aMessage = sprintf('Missing header_data %s',$MESSAGE['GENERIC_FILL_IN_ALL']);
        throw new \Exception ($aMessage);
    }
//Write Settings to Database
    $aSql = [];
    if (sizeof($msg)==0) {}
    $sql  = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_concert_settings` '
    . 'WHERE `section_id`='.$section_id.'';
    if (!($iNumRow = $database->get_one($sql))){
        $sSql  = 'INSERT INTO `'.TABLE_PREFIX.'mod_concert_settings` SET ';
        $sSqlWhere = '';
    } else {
        $sSql  = 'UPDATE `'.TABLE_PREFIX.'mod_concert_settings` SET ';
        $sSqlWhere  = 'WHERE `section_id` ='.$section_id.' ';
    }

    $aSql[0]  = '
          `page_id` = '.$page_id.'
          ,`header_data` = \''.$database->escapeString($header_data).'\'
          ,`footer_data` = \''.$database->escapeString($footer_data).'\'
          ,`ccloop`      = \''.$database->escapeString($ccloop).'\'
          ,`detailed_view` = '.(int)$detailed_view.'
          ,`previous_view` = '.(int)$previous_view.'
          ,`upcoming_view` = '.(int)$upcoming_view.'
          ,`previous_num` = '.(int)$previous_num.'
          ,`upcoming_num` = '.(int)$upcoming_num.'
          ,`dateview` = '.(int)$dateview.'
          ,`date_link` = '.(int)$date_link.'
          ,`toggle` = '.(int)$toggle.'
          ';
    $sSqlSet = $sSql.$aSql[0].$sSqlWhere;
    if (!$database->query($sSqlSet)){
        $aMessage = sprintf("%s\n%s ",$sSqlSet,$database->get_error());
        throw new \Exception ($aMessage);
    }

} catch (\Exception $ex) {
    $sErrMsg = PreCheck::xnl2br(\sprintf('[%03d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}
    $sExtra = '';
    $aMessage = PreCheck::xnl2br(sprintf('%s %s ',$sExtra,$MESSAGE['PAGES_SAVED']));
    $admin->print_success($aMessage, $sAddonBackUrl);


// Print admin footer
$admin->print_footer();

