<?php
/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue,ParentList};
use src\Security\{CsfrTokens,Randomizer};
use src\Interfaces\Requester;
use bin\Requester\HttpRequester;

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */

    $msg           = [];
    $mErrorMsg     = null;
    $sAddonPath    = \str_replace(['\\','//'], '/', (__DIR__)).'/';
    $sAddonName    = basename($sAddonPath);
    $globalStarted = preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
    $sPattern = "/^(.*?\/)modules\/.*$/";
    $sAppPath = preg_replace ($sPattern, "$1", $sAddonPath, 1 );
    $sTargetPath   = '';
//    $aImportFiles = glob($sTargetPath.'*.php', GLOB_NOSORT);

    $sWbVersion = ($globalStarted && defined('VERSION') ? VERSION : WB_VERSION);
    $sModulePlatform = PreCheck::getAddonVariable($sAddonName,'platform');
    if (version_compare($sWbVersion, $sModulePlatform, '<')){
        $msg[] = $mErrorMsg = sprintf('It is not possible to upgrade from WebsiteBaker Versions before %s',$sModulePlatform);
        if ($globalStarted){
            echo $mErrorMsg;
        }else{
            throw new \Exception ($mErrorMsg);
        }
    } else {
        $sSqlDumpFile = $sAddonPath.'/install-struct.sql';
        if (is_readable($sSqlDumpFile)) {
            // upgrade database tables
            if (!($database->SqlImport($sSqlDumpFile, TABLE_PREFIX, 'upgrade'))){
                $msg[] = $mErrorMsg = sprintf("It is not possible to upgrade\n %s \n %s",'',$database->get_error());
                if (!$globalStarted){throw new Exception ($mErrorMsg);}
            }
        }
    }

// update create_when columns
      $sql  = 'UPDATE `'.TABLE_PREFIX.'mod_concert_dates` '
            . 'SET `created_by`= 1, `created_when`= UNIX_TIMESTAMP(`concert_date`) '
            . 'WHERE `created_when` = 0';
      if (!($database->query($sql))){
          $mErrorMsg = sprintf($database->get_error());
          throw new \Exception ($mErrorMsg);
      }

// sanitize URLs inside mod_wysiwyg.content ----------------------------
        $sql = 'SELECT `concert_desc`, `section_id`, `concert_id` FROM `'.TABLE_PREFIX.'mod_concert_dates`';
        if (($oInstances = $database->query($sql))) {
            while (($aInstance = $oInstances->fetchRow(MYSQLI_ASSOC))) {
                // add $sDocumentRootUrl to relative URLs
                $sContent = $admin->ReplaceAbsoluteMediaUrl($aInstance['concert_desc']);
                // migrate old placeholder SYSVAR:MEDIA_REL to new format
//                $sContent = str_replace (['{SYSVAR:MEDIA_REL}/'],['{SYSVAR:AppUrl.MediaDir}'],$sContent);
                $sql = 'UPDATE `'.TABLE_PREFIX.'mod_concert_dates` '
                     . 'SET `concert_desc`=\''.$database->escapeString($sContent).'\' '
                     . 'WHERE `concert_id`='.$aInstance['concert_id'];
                if (!$database->query($sql)) {
                    $msg[] = $database->get_error();
                    break;
                }
            }// end while
        }
        if (is_readable(WB_PATH.'/modules/droplets/droplets.functions.php')) {
            require WB_PATH.'/modules/droplets/droplets.functions.php';
            $sDropletFiles = $sAddonPath.'/Droplets/concertlist.php';
            $aDropletFiles = [$sDropletFiles];
            if (is_readable($sDropletFiles)) {
                $bOverwriteDroplets = false;
                insertDropletFile($aDropletFiles, $database, $admin,$msg,$bOverwriteDroplets);
            } else {
                $msg[] = sprintf('%03d file not found %s',__LINE__,basename($sDropletFiles));
            }
        }

