<?php
/*

 Website Baker Project <http://www.websitebaker.org/>
 Copyright (C) 2004-2008, Ryan Djurovich

 Website Baker is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Website Baker is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue,ParentList};
use src\Security\{CsfrTokens,Randomizer};
use src\Interfaces\Requester;
use bin\Requester\HttpRequester;

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit; }
/* -------------------------------------------------------- */

    $sAddonPath = str_replace(['\\','//'],'/',(__DIR__)).'/'; $iSteps = 2;
    $sPattern = "/^(.*?\/)modules\/.*$/";
    $sAppPath = preg_replace ($sPattern, "$1", $sAddonPath, 1 );
    $oReg     = Wbadaptor::getInstance();
    $oDb      = $oReg->getDatabase();
    $oRequest = $oReg->getRequester();
    $oTrans   = $oReg->getTranslate();
    $oApp = $oReg->getApplication();
    $aMessage = [];
    $fetch_content = [];
try {
    $iSectionIdMain = $section_id;

    if (is_readable($sAddonPath.'config.ini')){
//  RL 110204 - Muss gleich dem Hauptmodul sein (concert)
        $aConfig = parse_ini_file($sAddonPath.'config.ini',true);
        $sectionId = ($aConfig['concert']['section_id'] ?? 0);
        $iSectionIdMain = $sectionId;
    }

    // load module language file
    if (\is_readable($sAddonPath.'languages/EN.php')) {require($sAddonPath.'languages/EN.php');}
    if (\is_readable($sAddonPath.'languages/'.DEFAULT_LANGUAGE.'.php')) {require($sAddonPath.'languages/'.DEFAULT_LANGUAGE.'.php');}
    if (\is_readable($sAddonPath.'languages/'.LANGUAGE.'.php')) {require($sAddonPath.'/languages/'.LANGUAGE.'.php');}
    $oLang = \Translate::getInstance();
    $oLang->enableAddon('modules\\'.\basename(__DIR__));
/*
    // check if frontend.css file needs to be included into the <body></body> of view.php
    if((!function_exists('register_frontend_modfiles') || !defined('MOD_FRONTEND_CSS_REGISTERED')) &&  file_exists(WB_PATH .'/modules/concert/frontend.css')) {
       echo '<style type="text/css">';
       include(WB_PATH .'/modules/concert/frontend.css');
       echo "\n</style>\n";
    }
*/
// Get settings
    $query = "SELECT * FROM ".TABLE_PREFIX."mod_concert_settings WHERE section_id = '$iSectionIdMain'";
    if (($oRes = $oDb->query($query))){
        if ($oRes->numRows() > 0) {
            if (($fetch_content = $oRes->fetchRow(MYSQLI_ASSOC))){
                $header_data = stripslashes($fetch_content['header_data']);
                $footer_data = stripslashes($fetch_content['footer_data']);
                $ccloop = stripslashes($fetch_content['ccloop']);
                $detailed_view = $fetch_content['detailed_view'];
                $upcoming_view = $fetch_content['upcoming_view'];
                $previous_view = $fetch_content['previous_view'];
                $previous_num = stripslashes($fetch_content['previous_num']);
                $upcoming_num = stripslashes($fetch_content['upcoming_num']);
                $dateview = $fetch_content['dateview'];
                $date_link = $fetch_content['date_link'];
                $toggle = $fetch_content['toggle'];
          }
        }
    }

    $requestMethod = \strtoupper($oReg->Request->getServerVar('REQUEST_METHOD'));
    $aRequestVars = [];
// get POST or GET requests, never both at once
    $aVars = $oReg->Request->getParamNames();
    foreach ($aVars as $sName) {
        $aRequestVars[$sName] = $oReg->Request->getParam($sName);
    }

    if (isset($_GET['date'])) {
        $date = $_GET['date'];
    }
    $today = date('Y-m-d');
    $date  = ($date ?? $today);
// Functions--------------------
    if (!function_exists('switch_date')){
        function switch_date($date, $dateview) {
            $oReg = Wbadaptor::getInstance();
            $oApp = $oReg->getApplication();
            if (!empty($date)) {
                list($a2year, $a2month, $a2day) = $oApp->convertToArray($date);
                $ydash="-";
                $ydot=".";
                    switch ($dateview):
                        case '1':
                        $altdate=$a2day.$ydot.$a2month.$ydot.$a2year;
                            break;
                        case '2':
                            $altdate=$a2month.$ydash.$a2day.$ydash.$a2year;
                            break;
                        default:
                            $altdate=$date;
                    endswitch;
                return $altdate;
            }
        }
    }
    if (!function_exists('output')){
        function output($data, $dateview, $MOD_CONCERT, $date_link, $ccloop, $toggle) {
            $search = [
                '[PLACE]',
                '[CLUB]',
                '[TIME]',
                '[PRICE]',
                '[NAME]',
                '[DATE]',
                '[INFO]'
            ];
            $replace = [
                $data['concert_place'],
                $data['concert_club'],
                $data['concert_time'],
                $data['concert_price'],
                $data['concert_name'],
                switch_date($data['concert_date'], $dateview),
                $data['concert_desc']
            ];
            $content = "";
            if ($date_link == 1) {$content .= '<i><a href="?date='.$data['concert_date'].'">' . switch_date($data['concert_date'], $dateview) . '</a></i>';}
            else {$content .= '<i>'.switch_date($data['concert_date'], $dateview).'</i>';}
            $content .= "&nbsp;&nbsp;";
            $divtxt = '"cc'.$data['concert_id'].'"';
            if ($toggle == 1) {
                $content .= " <a class='toggle' onclick='toggle_visibility(".$divtxt.");'>".$data['concert_name']."</a>";
            } else {
                $content .= $data['concert_name'];
            }
            $content .= "<div class='desc' id='cc".$data['concert_id']."' style='display:none;'>";
            $content .= str_replace($search, $replace, $ccloop);
            $content .= "</div>\n";
            $content .= "<br />\n";
            return $content;
        }
    }
    echo '<div id="concert-calendar">';
    echo '<div class="header_data">';
    if (!empty($header_data)) {
        echo $header_data;
    }
    echo '</div>';
?>
<script type="text/javascript">
<!--
    function toggle_visibility(id) {
       var e = document.getElementById(id);
       if(e.style.display == 'block')
          e.style.display = 'none';
       else
          e.style.display = 'block';
    }
//-->
</script>
<?php
if (isset($date) && $date == 'all') { // call for archive
?>

<!-- Display archive -->

<a href="?">&laquo; <?php echo $MOD_CONCERT['BACK']; ?></a>
<div class="concertborder">
    <h2 class="concertheading">
<?php
        echo $MOD_CONCERT['ARCHIVE'];
?>
    </h2>
    <div class="concert archive">
<?php
        $query_dates_archive = "SELECT * FROM `".TABLE_PREFIX."mod_concert_dates` WHERE `section_id` = '$iSectionIdMain' && concert_date < '$today' ORDER BY concert_date DESC LIMIT 200";
        if (($oRes = $oDb->query($query_dates_archive))){
            if ($oRes->numRows() > 0) {
                while (($result_archive = $oRes->fetchRow(MYSQLI_ASSOC))) {
                    echo output($result_archive, $dateview, $MOD_CONCERT, $date_link, $ccloop, $toggle);
                }
            } else {
                echo $MOD_CONCERT['ARCHIVE_EMPTY'];
            }
        }
?>
    </div>
</div>

<?php
} else { // No call for archive
?>
<!-- Display detailed events -->
<?php
if ($detailed_view == 1 ){
    $date_link2 = true;
    if (!empty($date)) {
        $query_new_date = "SELECT * FROM `".TABLE_PREFIX."mod_concert_dates` WHERE `section_id` = '$iSectionIdMain' && concert_date >= '$today' LIMIT 1";
        if (($oRes = $oDb->query($query_new_date))){
            if (($result_new_date = $oRes->fetchRow(MYSQLI_ASSOC))) {
                $date = $result_new_date['concert_date'];
                $date_link2 = false;
            }
        }
    }
//RL110204 -- Hinzugefuegt: Naechstes Konzertdatum wählen

    $query_dates = "SELECT * FROM ".TABLE_PREFIX."mod_concert_dates WHERE section_id = '$iSectionIdMain' && concert_date >= '$today' ORDER BY concert_date LIMIT $upcoming_num";
    if (($oRes = $oDb->query($query_dates))){
        if ($oRes->numRows() > 0) {
            $i = 0;
            while (($result = $oRes->fetchRow(MYSQLI_ASSOC))) {
                $i++;
                $result_new_date = $result['concert_date'];
                if ($result_new_date < $date) {$date = $result_new_date;}
            }

        }
    }
?>
<div class="concertborder">
    <h2 class="concertheading">
<?php
        if ($date_link2) {
            echo $MOD_CONCERT['DETAILED_VIEW'];
        } else {
            if (!empty($date)) {echo $MOD_CONCERT['NEXTCONCERT'];} else {echo $MOD_CONCERT['NOTHING_ARRANGED'];}
        }
        echo " ".switch_date($date, $dateview)." ";
        if ($date_link2) {
            echo '(<a href="?date='.$date.'">'.$MOD_CONCERT['BACK_TO_CURRENT'].'</a>)';
        }
?>
    </h2>
    <div class="concert next-concert">
<?php
        $query_dates = "SELECT * FROM ".TABLE_PREFIX."mod_concert_dates WHERE section_id = '$iSectionIdMain' && concert_date = '$date'";
        if (($oRes = $oDb->query($query_dates))){
            $i = 0;
            if (($num_rows =$oRes->numRows() > 0)) {
                while (($result = $oRes->fetchRow(MYSQLI_ASSOC))) {
                    $i++;
                    echo '<h3>' . $result['concert_name'] . '</h3>';
                    $search = [
                        '[PLACE]',
                        '[CLUB]',
                        '[TIME]',
                        '[PRICE]',
                        '[NAME]',
                        '[DATE]',
                        '[INFO]'
                    ];
                    $replace = [
                        $result['concert_place'],
                        $result['concert_club'],
                        $result['concert_time'],
                        $result['concert_price'],
                        $result['concert_name'],
                        switch_date($result['concert_date'], $dateview),
                        $result['concert_desc']
                    ];
                    $content = '<p>'.str_replace($search, $replace, $ccloop).'</p>';
                    if ($i < $num_rows) { $content .= '<hr />'; }
//                    $wb->preprocess($content);
                    echo $content;
                }
            } else {
                echo $MOD_CONCERT['NO_ENTRY'];
            }
        }
?>
    </div>
</div>
<?php } ?>

<!-- Display upcoming events -->

<?php if ($upcoming_view == 1 ){ ?>
<div class="concertborder">
    <h2 class="concertheading">
    <?php
        echo $MOD_CONCERT['UPCOMING_CONCERTS'];
    ?>
    </h2>
    <div class="concert upcoming">
<?php
        $query_dates_upcoming = "SELECT * FROM ".TABLE_PREFIX."mod_concert_dates WHERE section_id = '$iSectionIdMain' && concert_date > '$today' ORDER BY concert_date LIMIT $upcoming_num";
        if (($oRes = $oDb->query($query_dates_upcoming))){
            //RL110204 - 1. Ergebnis nicht mehr angezeigt
            //RL140328 - 1. Ergebnis doch wieder angezeigt
            if ($oRes->numRows() > 0) {
                while (($result_upcoming = $oRes->fetchRow(MYSQLI_ASSOC))) {
                    echo output($result_upcoming, $dateview, $MOD_CONCERT,$date_link, $ccloop, $toggle);
                }
            } else {
            echo $MOD_CONCERT['NO_ENTRY'];
            }
        }
?>
    </div>
</div>
<?php } ?>

<!-- Display previous events -->

<?php if ($previous_view == 1 ){ ?>
<div class="concertborder">
    <h2 class="concertheading">
<?php
        echo $MOD_CONCERT['PREVIOUS_CONCERTS'];
        echo ' (<a href="?date=all">'.$MOD_CONCERT['ARCHIVE'].'</a>)';
?>
    </h2>
    <div class="concert previous">
<?php
        $query_dates_previous = "SELECT * FROM ".TABLE_PREFIX."mod_concert_dates WHERE section_id = '$iSectionIdMain' && concert_date < '$today' ORDER BY concert_date DESC LIMIT $previous_num";
        if (($oRes = $oDb->query($query_dates_previous))){
            if ($oRes->numRows() > 0) {
                while (($result_previous = $oRes->fetchRow(MYSQLI_ASSOC))) {
                    echo output($result_previous, $dateview, $MOD_CONCERT, $date_link, $ccloop, $toggle);
                }
            } else {
                //echo $MOD_CONCERT['NO_ENTRY'];
            }
        }

?>
    </div>
</div>
<?php
}

} // end-else for 'no call for archive'
echo '<div class="footer_data">';
if ($footer_data != "" ) {
    echo $footer_data;
}
echo '</div>';
echo '</div>';

}catch (\Exception $ex) {
    $sErrMsg = PreCheck::xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $oApp->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}
